Subject: Re: TCP sender stuck in persist despite peer advertising non-zero window

From: Apollon Oikonomopoulos <[email-masked]>
Date: Fri, 16 Oct 2020 01:12:12 +0300

Yuchung Cheng <[email-masked]> writes:

> On Thu, Oct 15, 2020 at 1:22 PM Neal Cardwell <[email-masked]> wrote:
>>
>> On Thu, Oct 15, 2020 at 2:31 PM Apollon Oikonomopoulos <[email-masked]> wrote:
>> >
>> > Hi,
>> >
>> > I'm trying to debug a (possible) TCP issue we have been encountering
>> > sporadically during the past couple of years. Currently we're running
>> > 4.9.144, but we've been observing this since at least 3.16.
>> >
>> > Tl;DR: I believe we are seeing a case where snd_wl1 fails to be properly
>> > updated, leading to inability to recover from a TCP persist state and
>> > would appreciate some help debugging this.
>>
>> Thanks for the detailed report and diagnosis. I think we may need a
>> fix something like the following patch below.

That was fast, thank you!

>>
>> Eric/Yuchung/Soheil, what do you think?
> wow hard to believe how old this bug can be. The patch looks good but
> can Apollon verify this patch fix the issue?

Sure, I can give it a try and let the systems do their thing for a couple of
days, which should be enough to see if it's fixed.

Neal, would it be possible to re-send the patch as an attachment? The
inlined version does not apply cleanly due to linewrapping and
whitespace changes and, although I can re-type it, I would prefer to test
the exact same thing that would be merged.

Regards,
Apollon